#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include "lilith.fm.h"
#include "ScrobSubmitter.h"
#include "mp3infp_ExportFunc.h"

using namespace std;

#define APPLICATION_ID "tst"

// vg^Cv錾
#ifdef __cplusplus
extern "C" {
#endif

int WINAPI Initialize(HWND hwndOwner, VIS_GETSAMPLESPROC GetSamplesProc);
int WINAPI Uninitialize(void);

int WINAPI OpenSound(DWORD dwHandle, LPCSTR lpcszFileName, BOOL fIsFloat, DWORD dwBitsPerSample, DWORD dwSamplerate, DWORD dwChannels, __int64 TotalTime);
int WINAPI CloseSound(DWORD dwHandle);

int WINAPI Process(DWORD dwHandle, __int64 CurrentTime);
HWND WINAPI ShowProperty(HWND hwndOwner);

int WINAPI VISGetPluginInfo(LPVIS_PLUGIN_INFO lpInfo);

#ifdef __cplusplus
}
#endif

// O[oϐ
const static VIS_PLUGIN_INFO Info =
{
	0x1000, "Lilith.fm", "axelarist",
	"Lilith.fm", "http://www21.atwiki.jp/axelarist/", 
	{
	Initialize,
	Uninitialize,
	OpenSound,
	CloseSound,
	Process,
	ShowProperty,
	}
};

static struct GLOBALDATA
{
	BOOL fInitalized;
	HWND hwndOwner;
	DWORD dwHandle;
} global_data;

static HINSTANCE hinstVisLastfm = NULL;
static BOOL fVisLastfmInitialized = FALSE;
static LONG lVisLastfmAttatchedProcess = 0;
static CRITICAL_SECTION crsec;
static ScrobSubmitter g_csSubmitter;
static TAGINFO g_csTagInfo={0};

HMODULE g_hMp3infpDll;
LPMP3INFP_GETVER lpmp3infp_GetVer = NULL;
LPMP3INFP_LOAD lpmp3infp_Load = NULL;
LPMP3INFP_VIEWPROP lpmp3infp_ViewProp = NULL;
LPMP3INFP_GETTYPE lpmp3infp_GetType = NULL;
LPMP3INFP_GETVALUE lpmp3infp_GetValue = NULL;
LPMP3INFP_MP3_GETTAGTYPE lpmp3infp_mp3_GetTagType = NULL;
LPMP3INFP_SETCONF lpmp3infp_SetConf = NULL;

// C֐
BOOL APIENTRY DllMain(HINSTANCE hThisInstance, DWORD dwNotification, LPVOID lpReserved)
{
	//  ÓIf[^̏
	if (! fVisLastfmInitialized)
	{
		hinstVisLastfm = hThisInstance;		//  CX^Xnh̕ۑ

		InitializeCriticalSection(&crsec);
		fVisLastfmInitialized = TRUE;

		//  Xbh̃A^b`ʒmȂ悤ɂ
		DisableThreadLibraryCalls(hThisInstance);
	}

	//  vZX̃A^b`^f^b`̏
	if (dwNotification == DLL_PROCESS_ATTACH)
	{
		//  A^b`ꂽvZX̃JEg
		lVisLastfmAttatchedProcess++;
	}
	else if (dwNotification == DLL_PROCESS_DETACH)
	{
		//  A^b`ꂽvZX̃JEg
		lVisLastfmAttatchedProcess--;

		//  ÓIf[^̉
		if (lVisLastfmAttatchedProcess <= 0)
		{
			hinstVisLastfm = NULL;
			DeleteCriticalSection(&crsec);
			fVisLastfmInitialized = FALSE;
		}
	}

	return TRUE;
}

int WINAPI VISGetPluginInfo(LPVIS_PLUGIN_INFO lpInfo)
{
	CopyMemory(lpInfo, &Info, sizeof(VIS_PLUGIN_INFO));

	return 0;
}

// ݂̋Ȃ̃^O擾
long GetTagInfo(TAGINFO* pcsTagInfo, LPCSTR lpcszFileName)
{
	long lRtn = -1;

	if ( lpmp3infp_Load( 0, lpcszFileName ) == ERROR_SUCCESS )
	{
		// WAVER[fbN擾@ݒ
		lpmp3infp_SetConf("wave_CodecFind","0");

		//t@Cʂ擾
		DWORD type = lpmp3infp_GetType();
		char *buf = NULL;

		switch(type)
		{
			case MP3INFP_FILE_MP3:
				//A[eBXg
				lpmp3infp_GetValue("IART_v2",&buf);
				if ( !buf || ( *buf=='\0' ) )
				{// v1
					lpmp3infp_GetValue("IART_v1",&buf);
				}
				strcpy_s(pcsTagInfo->pszArtist, MAX_PATH, buf);

				//Ao
				lpmp3infp_GetValue("IPRD_v2",&buf);
				if ( !buf || ( *buf=='\0' ) )
				{// v1
					lpmp3infp_GetValue("IPRD_v1",&buf);
				}
				strcpy_s(pcsTagInfo->pszAlbum, MAX_PATH, buf);

				//^Cg
				lpmp3infp_GetValue("INAM_v2",&buf);
				if ( !buf || ( *buf=='\0' ) )
				{// v1
					lpmp3infp_GetValue("INAM_v1",&buf);
				}
				strcpy_s(pcsTagInfo->pszTitle, MAX_PATH, buf);

				break;
			case MP3INFP_FILE_WAV:
				//A[eBXg
				lpmp3infp_GetValue("IART",&buf);
				strcpy_s(pcsTagInfo->pszArtist, MAX_PATH, buf);

				//Ao
				lpmp3infp_GetValue("IPRD",&buf);
				strcpy_s(pcsTagInfo->pszAlbum, MAX_PATH, buf);

				//^Cg
				lpmp3infp_GetValue("INAM",&buf);
				if ( !buf )
				{//
					lpmp3infp_GetValue("ISBJ",&buf);
				}
				strcpy_s(pcsTagInfo->pszTitle, MAX_PATH, buf);

				break;
			case MP3INFP_FILE_WMA:
			case MP3INFP_FILE_OGG:
			case MP3INFP_FILE_APE:
				//A[eBXg
				lpmp3infp_GetValue("IART",&buf);
				strcpy_s(pcsTagInfo->pszArtist, MAX_PATH, buf);

				//Ao
				lpmp3infp_GetValue("IPRD",&buf);
				strcpy_s(pcsTagInfo->pszAlbum, MAX_PATH, buf);

				//^Cg
				lpmp3infp_GetValue("INAM",&buf);
				strcpy_s(pcsTagInfo->pszTitle, MAX_PATH, buf);

				break;
			default:
				break;
		}
	}

	return lRtn;
}

int WINAPI Initialize(HWND hwndOwner, VIS_GETSAMPLESPROC GetSamplesProc)
{
	EnterCriticalSection(&crsec);

	// 
	global_data.hwndOwner = hwndOwner;
	global_data.fInitalized = TRUE;
	global_data.dwHandle = 0;

	//DLL̃[h
	g_hMp3infpDll = LoadLibrary("mp3infp.dll");
	if(g_hMp3infpDll == NULL)
	{
		LeaveCriticalSection(&crsec);
		return 1;
	}

	lpmp3infp_GetVer = (LPMP3INFP_GETVER )GetProcAddress(g_hMp3infpDll,"mp3infp_GetVer");
	lpmp3infp_Load = (LPMP3INFP_LOAD )GetProcAddress(g_hMp3infpDll,"mp3infp_Load");
	lpmp3infp_ViewProp = (LPMP3INFP_VIEWPROP )GetProcAddress(g_hMp3infpDll,"mp3infp_ViewProp");
	lpmp3infp_GetType = (LPMP3INFP_GETTYPE )GetProcAddress(g_hMp3infpDll,"mp3infp_GetType");
	lpmp3infp_GetValue = (LPMP3INFP_GETVALUE )GetProcAddress(g_hMp3infpDll,"mp3infp_GetValue");
	lpmp3infp_mp3_GetTagType = (LPMP3INFP_MP3_GETTAGTYPE )GetProcAddress(g_hMp3infpDll,"mp3infp_mp3_GetTagType");
	lpmp3infp_SetConf = (LPMP3INFP_SETCONF )GetProcAddress(g_hMp3infpDll,"mp3infp_SetConf");

	// Last.fm
	g_csSubmitter.Init(APPLICATION_ID, NULL, 0);

	LeaveCriticalSection(&crsec);

	return 0;
}

int WINAPI Uninitialize(void)
{
	EnterCriticalSection(&crsec);

	// ㏈ł
	global_data.fInitalized = FALSE;

	// Last.fmI
	g_csSubmitter.Term();

	LeaveCriticalSection(&crsec);

	return 0;
}

int WINAPI OpenSound(DWORD dwHandle, LPCSTR lpcszFileName, BOOL fIsFloat, DWORD dwBitsPerSample, DWORD dwSamplerate, DWORD dwChannels, __int64 CurrentTime)
{
	char pszBuff[512] = {0};

	EnterCriticalSection(&crsec);
	if (! global_data.fInitalized)
	{
		LeaveCriticalSection(&crsec);
		return -1;
	}

	if (dwHandle != global_data.dwHandle)
	{
		global_data.dwHandle = dwHandle;
		//strcpy_s(global_data.pszPath, lpcszFileName);
	}

	// ^O擾
	GetTagInfo(&g_csTagInfo, lpcszFileName);

	// Last.fmJn
	g_csSubmitter.Start(g_csTagInfo.pszArtist, g_csTagInfo.pszTitle, g_csTagInfo.pszAlbum, "", CurrentTime/1000, lpcszFileName, (ScrobSubmitter::Encoding)0);

	LeaveCriticalSection(&crsec);

	return 0;
}

int WINAPI CloseSound(DWORD dwHandle)
{
	if (dwHandle == global_data.dwHandle)
	{
		// Last.fm~
		g_csSubmitter.Stop();
		global_data.dwHandle = 0;
	}
	
	return 0;
}

int WINAPI Process(DWORD dwHandle, __int64 CurrentTime)
{
	static __int64 BeforeTime = -1;
	static bool BeforeStopWrite = false, BeforePlayingWrite = false;
	int ret = -1;

	EnterCriticalSection(&crsec);


	if (! global_data.fInitalized)
	{
		BeforeTime = CurrentTime;
		LeaveCriticalSection(&crsec);
		return ret;
	}

	if (dwHandle == global_data.dwHandle)
	{

		//t[̏
		if ( BeforeTime == CurrentTime )
		{
			if ( !BeforeStopWrite )
			{
				g_csSubmitter.Pause(); // Last.fmꎞ~
				BeforeStopWrite = true;
				BeforePlayingWrite = false;
			}
		}
		else
		{
			if ( !BeforePlayingWrite )
			{
				g_csSubmitter.Resume(); // Last.fmĊJ
				BeforePlayingWrite = true;
				BeforeStopWrite = false;
			}
		}

		ret = 0;
	}

	BeforeTime = CurrentTime;

	LeaveCriticalSection(&crsec);
	return ret;
}

HWND WINAPI ShowProperty(HWND hwndOwner)
{
	MessageBoxA(hwndOwner, "Lilith.fm v0.900", "Lilith.fm", MB_OK);
	return NULL;
}
